#!/usr/bin/perl -w
# $Id: killwater.pl,v 1.6 2001/11/27 17:38:45 oliver Exp $
# $Log: killwater.pl,v $
# Revision 1.6  2001/11/27 17:38:45  oliver
# Updated with changes that accumulated over the RCS-less time
#
# Revision 1.5  2001/01/31 20:31:34  oliver
# seems to work
#
# Revision 1.4  2001/01/30 21:12:31  oliver
# shit -- does not work
#
# Revision 1.3  2001/01/30 20:18:49  oliver
# Bug: wrong number of atoms ??
#
# Revision 1.2  2001/01/26 23:21:39  oliver
# fixed some bugs in original script:
# - check if buffer empty after main loop
# - write correct total number of atoms
#

# this program reads a gromos file (.gro) and does evil things to
# molecules with certain properties. 
# In this case, it kills all watermolecules below a certain z and above 
# a certain z.
# usage: killwater.pl z1 z2 input.gro > output.gro

#$DEBUG = 'true';

if (@ARGV != 3) 
{
    print STDERR "Wrong number of arguments.\n
	Usage killwater.pl z1 z2 input.gro";
}    

open(COOR, $ARGV[2]) || die "Can't open $ARGV[2]: $!\n";
open(LOG,">killwater.log");

@FILE = <COOR>;			# Be bold, just read in entire file

($nr_res) = $FILE[$#FILE-1] =~ /(\d+)/;
print STDERR "number of residues before: $nr_res\n";

######### Initialize variables ############
$left_z = $ARGV[0]; $right_z = $ARGV[1];
$keep = 2;
$current_resnum = 1;
$current_atom = 0;
$still_valid = 1;

$length = scalar(@FILE);


# extract unitcell
foreach $line (@FILE) {
    if ($line =~ /^ +[0-9.]+ +[0-9.]+ +[0-9.]+/ ) {$unitcell = $line};
};

print STDERR "Going to remove all water molecules between $left_z and $right_z!\n";


# This routine goes through a coordinate file and removes groups with a
# certain name (SOL in this case) that have one or more atoms with a z-
# coordinate of < left_z or > right_z. One entire residue is analyzed and
# written to the output, with renumbered groups and atoms.

print STDERR "Length = $length lines\n";

print LOG "file: $ARGV[2]\n";
print LOG "original length: $length lines\n";
print LOG "unitcell: $unitcell\n"; 


$outbuffer = "";
$buffer = "";
$buf = "";
$reject_count = 0;
$last_atom = 0;
$count_res = 0;

$template = "A5 A5 A5 A5 A8 A8 A8 A8 A8 A8 A1";



LINE: foreach $line (@FILE[2..($length-1)]) 
{
    # only process atom entries
    #    1234ATOM ....
    next LINE if ($line !~ /^ *[0-9]+[a-zA-Z]+/);

    # get data from fixed format gro file
    ($resnr,$resname,$atomname,$atomnr,$x,$y,$z,$vx,$vy,$vz) = 
	unpack($template,$line);


   if ($keep == $resnr) # we're in the next residue now
   {
       if ($DEBUG) {printf STDERR 
  	     "##### new residue[%4d] ##### last kept [%4d] ######\n",
	     $resnr, $current_resnum};
       if ($buffer)	# if there was something in the buffer,
       {		# print it.
	   $outbuffer .= $buffer;
	   if ($DEBUG) {print STDERR "outbuffer resnum [$current_resnum]:\n " 
			    . $buffer};
	   $current_resnum++;          # update residue number
	   $last_atom = $current_atom; # update total number of atoms
       }			
       # this group is now current group
       $keep = $resnr+1;       
       $buffer = "";
       $still_valid = 1;	

       # counts atoms in each  residue again
       $count_res = 0;
       $reject_count = 0;
   };

    if ($DEBUG) {
	$count++;
	print STDERR "line in COOR:   [$count] $line";
    };


   ($sol) = $resname =~ /SOL/; # check if group contains SOL
   
   if ((($z < $left_z || $z > $right_z) && $still_valid) 
       || !$sol )		# if in range, or not a solvent, print buffer
   {
       $count_res++;
       $current_atom = $last_atom + $count_res;
       # $current_atom++;		# update atom number
       if ( $vx  !~ / */ && $vx  !~ / */ && $vx  !~ / */) {
	   $buf = sprintf("%5d%-5s%5s%5d%8.3f%8.3f%8.3f%8.4f%8.4f%8.4f\n",
		      $current_resnum,$resname,$atomname,$current_atom,
		      $x,$y,$z,$vx,$vy,$vz);
       } else {
	   $buf = sprintf("%5d%-5s%5s%5d%8.3f%8.3f%8.3f\n",
		      $current_resnum,$resname,$atomname,$current_atom,
		      $x,$y,$z);
       };
       $buffer = $buffer . $buf;
   }
   else
   {
       $buffer = "";	        # delete value of $buffer;
       $still_valid = 0;	# don't print to buffer anymore for this group
       $reject_count++;
       if ($DEBUG) {
	   printf STDERR 
            "---- atomnr [%5d] rejected [%2d] -- REJECTED ----------------\n", 
	   ($current_atom+$reject_count), $reject_count};
   }
}

if ($buffer)	# if there was something in the buffer,
{		# print it.
    $outbuffer .= $buffer;
}			


# ????????????
#$current_atom -= 2;

# header of new gro file
# NEW number of atoms (after kill)
$outbuffer  = $FILE[0] . sprintf "$current_atom\n" . $outbuffer;
$outbuffer .= $unitcell;

print $outbuffer;

print LOG "Final length: $current_atom";

close (COOR);
close (LOG);




